// fontdemo.cpp: C++ source code for the FontDemo program.

#include <afxwin.h>                 
#include <afxdlgs.h>

#include "resources.h"
#include "..\include\fontlib.h"
#include "windemo.h"
#include "dos.h"


size_t FontFileSize(char *FontFile);
size_t FontFileLength=0;

struct text TextStruct;

//--------------------------------------------------------------------
#define     MAX_NUM_PRIMITIVES_FILE 2000   /* primitive file length */
struct primitivefile Display[MAX_NUM_PRIMITIVES_FILE];

extern TEXTOUPUTSTATE  OuttextState;  /* structure returned by Text() function */
#define DisplayIndex (OuttextState.LastPrimitiveIndex)
//--------------------------------------------------------------------



char *BufferFonts;    
struct TextStyle Normal={ "Normal",          /* definition of Style */      
                          "classic4.fnt",     /* definition of the font file */      
                           0.0,              /* heigth         RESERVED */   
                           1.0,              /* with           RESERVED */   
                           0.0,              /* Obiquing angle RESERVED */   
                           FALSE,            /* BackWard       RESERVED */   
                           FALSE,            /* UpsideDown     RESERVED */   
                           HORIZONTAL};      /* initialized to HORIZONTAL */


// 1. Define the window and application classes:
//------------------------------------------------------------------------
class CWindow : public CFrameWnd
{
public:
   CWindow ()
   {
      Create(NULL,"Vectorial Font Demo",WS_OVERLAPPEDWINDOW,rectDefault,NULL,"Greet2Menu");
   }
      
   afx_msg void OnLoadFont(void);   
   afx_msg void OnEdit(void);
   afx_msg void OnAbout (void);
   afx_msg void OnExit (void);
   afx_msg void OnPaint (void);
   DECLARE_MESSAGE_MAP ()
};
//------------------------------------------------------------------------
class CApp : public CWinApp
{
public:
   virtual BOOL InitInstance ();
};
//------------------------------------------------------------------------

// 2. Implement the member functions:
//--------------------------------------------------------------------------
afx_msg void CWindow::OnAbout ()
{    
CModalDialog DialogAbout(IDD_ABOUT);
DialogAbout.DoModal();
}
//---------------------------------------------------------------------
afx_msg void CWindow::OnLoadFont()
{
static int CallocUsed=FALSE;

CFileDialog LoadFontDlg(TRUE,"FNT","*.FNT",OFN_PATHMUSTEXIST,"Font Files (*.fnt)|*.FNT|All Files (*.*)|*.*||");


UserSetPF(Display , MAX_NUM_PRIMITIVES_FILE); /* initialize th eprimitive file */  

if((LoadFontDlg.DoModal()==IDOK))   /* once the Ok is pressed */
   {                   
   strcpy(Normal.FontFile,LoadFontDlg.GetPathName()); // assign the new font file 
   
   if((FontFileLength=FontFileSize(Normal.FontFile))<=(size_t)0)   // get the size 
     { 
     MessageBox("Font file name corrupted",NULL,MB_APPLMODAL | MB_OK);
     return;
     }           
     
   if(CallocUsed==TRUE)
      free((void *) BufferFonts);
       
     
   // get some memory to the buffer that will load the font file (allocated memory) 
   if((BufferFonts=( char *) malloc(sizeof(char)*(size_t)FontFileLength))==(char *)NULL)
      {                                                               
      MessageBox("Not enough memory, close other applications",NULL,MB_APPLMODAL | MB_OK);
      return;                                    
      }
   
   CallocUsed=TRUE;       
   // Initialize the Style
   if(InitStyle(Normal,BufferFonts,FontFileLength)!=OK)
     {
     MessageBox("Not a valid font file, cant read properly",NULL,MB_APPLMODAL | MB_OK);
     return;                                    
     }
   
   // enable the edit menu
   
   GetMenu()->EnableMenuItem(IDM_EDIT,MF_ENABLED);
   DrawMenuBar();
   }
}
//------------------------------------------------------------------------
afx_msg void CWindow::OnEdit()
{ 
CTextDlg EditDlg(IDD_TEXTSETTING);
EditDlg.DoModal();
Invalidate(TRUE);        // Force OnPaint call
UpdateWindow();

}
//---------------------------------------------------------------------------
afx_msg void CWindow::OnPaint ()
{                                     
// Lets draw the text to the window

char  *Buffer;
char *ptr, *ptr1;  
RW_POINT  Temp;                     
RW_POINT  Temp1;                     
                     
CPaintDC myDC(this);                 
RECT Rect;

GetClientRect(&Rect);

Buffer=strdup(TextStruct.String);
ptr=Buffer;


Temp.y=TextStruct.Pt1.y;
Temp.x=TextStruct.Pt1.x;

Temp1.y=TextStruct.Pt2.y;
Temp1.x=TextStruct.Pt2.x;


char EOLFlag=0;
while(*ptr!=0)            
     {          
     ptr1=ptr;
     
      while(*ptr1!='\r' && *ptr1!=0)
           ++ptr1;
      
      if(*ptr1==0)
        EOLFlag=1;
        
      if(*ptr1=='\r')  
        {
        *ptr1='\n';          
        *(++ptr1)=0;
        }

     OuttextState=Text(
                     ptr,              /* string to output */
                     TextStruct.Justification,       /* the justification is in the header */
                     Temp,                 /* first point */
                     Temp1,                 /* second point */
                     TextStruct.Heigth,              /* Heigth of the font */
                     TextStruct.Angle*(3.1415/180.0),/* Angle to rotate (Radians)*/
                     BufferFonts );       /* The Buffer where the font is loaded */
     
     
      if(!EOLFlag)                                            
       ptr=++ptr1;
      else
       ptr=ptr1;
       
    
   for(unsigned long i=0;i<DisplayIndex;i++)
       {
       if(Display[i].OpCode==PFMOVETO)   
         myDC.MoveTo((short)Display[i].x,Rect.bottom-(short)Display[i].y); 
       else                       
          myDC.LineTo((short)Display[i].x,Rect.bottom-(short)Display[i].y);  
       }                 
       
   if(TextStruct.Justification==FIT)       // The last Y point changes
     Temp1.y=Temp1.y+(OuttextState.LastPt.y-Temp.y);
   
    /* Pt1.x does not change, it keeps the initial value */
   Temp.y=OuttextState.LastPt.y;
  }

free((void *)Buffer);                
}

//--------------------------------------------------------------------------
afx_msg void CWindow::OnExit ()
{
DestroyWindow ();
}
//--------------------------------------------------------------------------
BEGIN_MESSAGE_MAP (CWindow, CFrameWnd)
   ON_COMMAND (IDM_ABOUT, OnAbout)
   ON_COMMAND (IDM_EXIT ,  OnExit)   
   ON_COMMAND (IDM_EDIT ,  OnEdit)   
   ON_COMMAND (IDM_LOAD ,  OnLoadFont)
   ON_WM_PAINT ()
END_MESSAGE_MAP ()
//--------------------------------------------------------------------------
BOOL CApp::InitInstance()
{        
   m_pMainWnd = new CWindow ();
   m_pMainWnd->ShowWindow (m_nCmdShow);
   return TRUE;
}
//--------------------------------------------------------------------------
// 3. Declare an instance of the derived application class:

CApp Greet2App;

//------------------------------------------------------------------------
/*-------------------------------------------------------*/
size_t FontFileSize(char *FontFile);
size_t FontFileSize(char *FontFile)
{
struct find_t Buffer;
_dos_findfirst(FontFile,_A_NORMAL,&Buffer);
return((size_t)Buffer.size);
}
/*------------------------------------------------------------------------*/
